program FLAME;
{$R-}

type  TScr = array[0..202,0..319] of Byte;
var  Scr: TScr absolute $A000:$0000;

procedure SetPalette;
var   N : Longint;
begin
  Port[$3C8] := 0;
  for N := 0 to 63 do begin
    Port[$3C9] := N;
    Port[$3C9] := 0{(N+64) div 65 * Sqr(63-N) div 128{};
    Port[$3C9] := 0{(N+64) div 65 * Sqr(63-N) div 128{};
  end;
  for N := 64 to 255 do begin
    Port[$3C9] := 0;
    Port[$3C9] := 31;
    Port[$3C9] := 31;
  end;
end; {of SetPalette}

var   X, Y, S, I: Integer;
begin
  asm mov ax,$13; int $10; end;
  SetPalette;
  for X:=50 to 319-50 do
    for Y:=97 to 103 do
      Scr[Y,X]:=255;
  Scr[100,319-50]:=63;
{  for X:=0 to 319 do
    for Y:=0 to 199 do
      Scr[Y,X]:=255;
  Scr[100,160]:=63;{}
  repeat
    for I:=1 to 1000 do begin
      X:=Random(318)+1;
      Y:=Random(200)+1;
      S:=Scr[Y,X];
      if (S<64) and (S>0) then begin
{        if S>0 then Dec(S);}
        if Scr[Y-3,X]<64 then Scr[Y-3,X]:=(Scr[Y-3,X]+S) shr 1 else if S>0 then Scr[Y-3,X]:=63;
        if Scr[Y-2,X]<64 then Scr[Y-2,X]:=(Scr[Y-2,X]+S) shr 1 else if S>0 then Scr[Y-2,X]:=63;{}
        if Scr[Y-1,X]<64 then Scr[Y-1,X]:=(Scr[Y-1,X]+S) shr 1 else if S>0 then Scr[Y-1,X]:=63;
        if Scr[Y+1,X]<64 then Scr[Y+1,X]:=(Scr[Y+1,X]+S) shr 1 else if S>0 then Scr[Y+1,X]:=63;
        if Scr[Y,X-1]<64 then Scr[Y,X-1]:=(Scr[Y,X-1]+S) shr 1 else if S>0 then Scr[Y,X-1]:=63;
        if Scr[Y,X+1]<64 then Scr[Y,X+1]:=(Scr[Y,X+1]+S) shr 1 else if S>0 then Scr[Y,X+1]:=63;
      end;
    end;
  until Port[$60]<128;
  asm mov ax,$03; int $10; end;
end.
