program FLAME;
{$R-}
uses Crt;

const Bottom=190;
type  T = array[0..202,0..319] of Byte;
var   M,MM : ^T;
var  Scr: T absolute $A000:$0000;

procedure SetPalette;
var   N : Longint;
begin
  Port[$3C8] := 0;
  for N := 0 to 255 do begin
    Port[$3C9] := N div 4;
    Port[$3C9] := 0;
    Port[$3C9] := 0;
  end;
end; {of SetPalette}

var   X, Y, I, S, DX, DY, C ,TT: Integer;
label m1,m2;
const R:Byte=255;
begin
  TT:=0;
  New(M); FillChar(M^,SizeOf(M^),0);
  asm mov ax,$13; int $10; end;
  SetPalette;
  repeat
    Inc(TT);
    Scr[100+Round(50*Sin(TT*2*PI/1024)),160+Round(60*Cos(TT*2*PI/1024))] := R;
    if KeyPressed then case ReadKey of
      '+': if R<=245 then Inc(R,10);
      '-': if R>=10 then Dec(R,10);
      ^M : R:=-R;
      ' ': ReadKey;
      #27:Break;
    end;
    for I:=0 to 10 do begin
      X:=Random(318)+1;
      Y:=Random(199)+1;
      S:=Scr[Y,X];
      if S>=4 then Dec(S,4);
      Scr[Y-1,X+1]:=S;
      Scr[Y-1,X]:=S;
      Scr[Y-1,X-1]:=S;
      Scr[Y+1,X]:=S;
    end;
  until False;
  asm mov ax,$03; int $10; end;
  Dispose(M);
end.
